# Copyright (C) [2006-2007] Novell, Inc.  All Rights Reserved.

# THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
# IT MAY NOT BE USED, COPIED, DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED,
# DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR WRITTEN
# CONSENT.  USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
# SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.

# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK,
# AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
# OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE,
# ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER
# DEALINGS IN THE WORK.

$MIG_DEBUG = false 

require 'migration/constants'
require 'migration/exception' # New error processing
require 'migration/errors' # New error processing
require 'migration/yaml'
require 'migration/keystore'
require 'migration/safe_pty'
require 'migration/migenv'
require 'migration/migmount'
#require 'migration/migtrustbar'
require 'migration/migutils'
require 'migration/parseargs'  # for now
require 'migration/parseargs2' # new parse args
require 'migration/volume'
require 'migration/nss'
require 'migration/migldap'
require 'migration/windows/exceptions'
require 'migration/windows/directory_tree'
require 'migration/windows/rights/translator'
require 'migration/windows/samba/samba'
require 'migration/windows/domain/group_object'
require 'migration/windows/domain/user_object'
require 'migration/windows/domain/operations'

file = ""

unless ENV['LANG'].nil?
  file = File.expand_path(File.join(File.dirname(__FILE__), 'lang')) +
    '/' + ENV['LANG'] + '.yaml'
end

# Set the default language
unless File.exists? file 
  file = File.expand_path(File.join(File.dirname(__FILE__), 'lang')) +
    '/en_US.UTF-8.yaml'
end

YAML::load_stream( file )
