# Copyright (C) [2006-2007] Novell, Inc.  All Rights Reserved.

# THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
# IT MAY NOT BE USED, COPIED, DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED,
# DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR WRITTEN
# CONSENT.  USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
# SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.

# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK,
# AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
# OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE,
# ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER
# DEALINGS IN THE WORK.
module Migration
  class MigrationException < StandardError
    attr_reader :code
    
    # Initialize contains 2 optional arguments.  The first is called
    # values.  Values is a hash of values that are to be added to the
    # error string on return.  These must map 1:1 to the error string in 
    # the MigrationErrors hash.  The second option is a debug string to be
    # used for debug. 
    def initialize( error, values = {}, debug = nil )
      if error.class == String
        @code = 1
        @message = eval('"' + error + '"')
      else
        @code = error.first
        @message = eval('"' + error.last + '"')
      end
      
      if not debug.nil? and $MIG_DEBUG
        @message += "\n Debug: #{@debug}"
      end      
    end
    
    def warning?
      if (@code >= 1000 and @code <= 1249 ) or 
         (@code >= 1500 and @code <= 1749 ) or
         (@code >= 2000 and @code <= 2249 )
        true
      else
        false
      end 
    end      
    
    def error?
      if (@code >= 1250 and @code <= 1449 ) or 
         (@code >= 1750 and @code <= 1999 ) or
         (@code >= 2250 and @code <= 2499 )
        true
      else
        false
      end  
    end
    
    def generic?
      (@code >= 1000 and @code <= 1499) ? true : false
    end
 
    def netware?
      (@code >= 1500 and @code <= 1999) ? true : false
    end
 
    def windows?
      (@code >= 2000 and @code <= 2499) ? true : false      
    end
    
    def to_s
      @message
    end
  end
  class MigSyntaxError < SyntaxError
    attr_reader :code

    def initialize(error)
        if error.class == String
		@code = 1
		@message = eval('"' + error + '"')
	end
	end
    def to_s
	@message
    end
  end
  class LdapAuthError < SystemExit
    attr_reader :code

    def initialize(error)
        if error.class == String
		@code = 1
		@message = eval('"' + error + '"')
	end
	end
    def to_s
	@message
    end
  end
end

