# Copyright (C) [2006-2007] Novell, Inc.  All Rights Reserved.

# THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
# IT MAY NOT BE USED, COPIED, DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED,
# DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR WRITTEN
# CONSENT.  USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
# SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.

# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK,
# AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
# OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE,
# ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER
# DEALINGS IN THE WORK.
require 'yaml'

module Migration

	MIGFILE = "#{ENV['HOME']}/.migration"

=begin
	def Migration.env_prompt (source, username, password)
		if source == nil or source == ""
			print "migration source (hostname or IP address)> "
			source = $stdin.gets.chomp
		end
		if username == nil or username == ""
			print "migration source admin username and context (e.g cn=admin,o=mycompany)> "
			username = $stdin.gets.chomp
			unless username.include? "cn="
				print "invalid credential"
				exit
			end
		end
		if password == nil or password == ""
			print "migration source admin user password> "
			password = $stdin.gets.chomp
		end
		return [source, username, password]
	end

	def Migration.env_write (source, username, password)
		sources = Migration.env_readall()
		File.open "#{MIGFILE}",File::CREAT|File::WRONLY|File::TRUNC,0600 do |migfile|
			credentials = {'USER'=>username, 'PASS'=>password}
			sources[source] = credentials
			migfile.write Marshal.dump(sources)
			#migfile.write "export MIGSOURCE=#{source}\n"
			#migfile.write "export MIGUSER=#{username}\n"
			#migfile.write "export MIGPASSWORD=#{password}\n"
			##migfile.write "export MIGPATH=/opt/novell/migrate/bin\n"
		end
	end
=end
	def Migration.env_prompt (source, source_name, source_pass)
		Migration.env_prompt_all(source, source_name, source_pass, nil, nil, nil, false, false)
	end

	def Migration.env_promptdest (dest, dest_name, dest_pass)
		Migration.env_prompt_all(nil, nil, nil, dest, dest_name, dest_pass, false, true)
	end

	def Migration.env_prompt_all (source, source_name, source_pass, dest, dest_name, dest_pass, all, dest_only = false)
		unless dest_only 
			if source == nil or source == ""
				print "migration source (hostname or IP address)> "
				source = $stdin.gets.chomp
			end
			if source_name == nil or source_name == ""
				print "migration source admin username and context (e.g cn=admin,o=mycompany)> "
				source_name = $stdin.gets.chomp
				unless source_name.include? "cn="
					print "invalid credential"
					exit
				end
			end
			if source_pass == nil or source_pass == ""
				print "migration source admin user password> "
				source_pass = $stdin.gets.chomp
			end
		end

		if all == true or dest_only == true
			if dest == nil or dest == ""
				print "migration destination (hostname or IP address)> "
				dest = $stdin.gets.chomp
			end
			if dest_name == nil or dest_name == ""
				print "migration destination admin username and context (e.g cn=admin,o=mycompany)> "
				dest_name = $stdin.gets.chomp
				unless dest_name.include? "cn="
					print "invalid credential"
					exit
				end
			end
			if dest_pass == nil or dest_pass == ""
				print "migration destination admin user password> "
				dest_pass = $stdin.gets.chomp
			end
		end
		if dest_only 
			return [dest, dest_name, dest_pass]
		else
			return [source, source_name, source_pass, dest, dest_name, dest_pass] 
		end
	end

	
	def Migration.env_write (source, source_name, source_pass)
		Migration.env_writeall(source, source_name, source_pass, nil, nil, nil)
	end
	
	def Migration.env_writedest (dest, dest_name, dest_pass)
		Migration.env_writeall(nil, nil, nil, dest, dest_name, dest_pass)
	end

	def Migration.env_writeall (source, source_name, source_pass, dest, dest_name, dest_pass)
		#puts "source:#{source}, source_name:#{source_name}, source_pass:#{source_pass}"
		#puts "dest:#{dest}, dest_name:#{dest_name}, dest_pass:#{dest_pass}"
		s = {'address' => source, 'username' => source_name, 'password' => source_pass} unless source == nil
		d = {'address' => dest, 'username' => dest_name, 'password' => dest_pass} unless dest == nil
		ENV['MIGSOURCE'],ENV['MIGUSER'],ENV['MIGPASSWORD'] = source, source_name, source_pass
		ENV['MIGDEST'],ENV['MIGDESTUSER'],ENV['MIGDESTPASSWORD'] = dest, dest_name, dest_pass
		if File.exists?(MIGFILE)
			stufo = YAML.load(File.open("#{MIGFILE}"))
		end
		if dest == nil or dest == ""
			stufobatcha = {source => s} 
		elsif source == nil or source == ""
			stufobatcha = {dest => d} 
		else
			stufobatcha = {source => s, dest => d} 
		end

		if File.exists?(MIGFILE)
			stufobatcha.merge!(stufo)
		end

		#stufobatcha.each {|s| p "s: #{s}"} unless stufobatcha == nil
		#stufo.each {|r| p "r: #{r}"} unless stufo == nil

		File.open "#{MIGFILE}",File::CREAT|File::WRONLY|File::TRUNC,0600 do |migfile|
			migfile.write(YAML.dump(stufobatcha))	
		end
	end


	def Migration.env_read(source) 
		Migration.env_readall(source, nil) 
	end

	def Migration.env_readdest(dest)
		Migration.env_readall(nil, dest)
	end
	
	def Migration.env_readall(source, destination) 
		if File.exists?(MIGFILE)
			creds = YAML.load(File.open("#{MIGFILE}"))
			unless source == nil
				s = creds[source]
				ENV['MIGSOURCE'],ENV['MIGUSER'],ENV['MIGPASSWORD'] = s['address'], s['username'],s['password'] unless s == nil
			end
			unless destination == nil
				d = creds[destination]
				ENV['MIGDEST'],ENV['MIGDESTUSER'],ENV['MIGDESTPASSWORD'] = d['address'],d['username'],d['password'] unless d == nil
			end
		end
	end

=begin
	def Migration.env_readall ()
		if File.file?("#{MIGFILE}")
			File.open "#{MIGFILE}", "r" do |migfile|
				sources = migfile.read()
				if sources == ""
					return {}
				else
					return Marshal.load(sources)
				end
			end
		end
		return {}
	end

	def Migration.env_read (key)
		if File.file?("#{MIGFILE}")
			File.open "#{MIGFILE}", "r" do |migfile|
				sources = migfile.read()
				if sources == ""
					sources = {}
				else
					sources = Marshal.load(sources)
				end
				if sources.has_key?(key)
					ENV['MIGSOURCE'] = key
					ENV['MIGUSER'] = sources[key]['USER']
					ENV['MIGPASSWORD'] = sources[key]['PASS']
				end
			end
		end
	end
=end
	
	def Migration.just_username(username)
		return username[username.index("=")+1..username.index(",")-1]
	end
  
  #--------------------------------------------------------------------------
  #BEGIN WINDOWS
  #--------------------------------------------------------------------------
  $:.unshift File.expand_path(File.join(File.dirname(__FILE__), '..'))
  require 'migration/windows/exceptions'        
  $:.shift     

  include Migration::Windows
  
  # Prompt user on stdin for Windows server information
  # 
  # :call-seq:
  #   Migration.env_windows_prompt( record  ) -> hash
  #   
  # Returns a hash of credential information
  def Migration.env_windows_prompt( record  )  
    credentials = Hash.new
    credentials['address'] = record
    credentials['username'] = ""
    credentials['password'] = ""
    credentials['workgorup'] = ""
    
    print "Enter the user name for #{record}: "
    credentials['username'] = $stdin.gets.chomp    
    
    if credentials['username'].empty?
      puts "User name cannot be blank!"
      print "Enter the user name for #{record}: "
      credentials['username'] = $stdin.gets.chomp    
      
      if credentials['username'].empty?
        raise WindowsError, 
          "Invalid user name, you must enter a valid user name.", caller
      end
    end
    
    #Used to catch <ctrl>-c interupts.  The terminal would not 
    #echo keystrokes back to the console with out it.
    begin
      print "Enter your password: "
      `stty -echo`
      credentials['password'] = $stdin.gets.chomp
      `stty echo`
      print "\n"    
    ensure
      `stty echo`
    end
    
    print "Enter the workgroup or domain for #{record}: "
    credentials['workgroup'] = $stdin.gets.chomp    
    
    return credentials
  end
 
  #Write record information to file in YAML
  # 
  # :call-seq:
  #   Migration.evn_windows_write( record ) -> nil
  #   
  # Returns a hash of credential information 
  def Migration.evn_windows_write( record )
    Migration.env_windows_write( record['address'], record['address'], 
        record['username'], record['password'], record['workgroup'] )
  end
  
  #Write record information to file
  # 
  # :call-seq:
  #   Migration.evn_windows_write( record, address, username, password, workgroup ) -> nil
  #   
  # Returns a hash of credential information
  def Migration.env_windows_write( record, address, username, password, workgroup )
    records = Hash.new
    
    if File.exists?( MIGFILE )
      records = YAML.load( File.open( MIGFILE ))
    end
    
    #update
    if records.has_key? record
      records[ record ]['address'] = address
      records[ record ]['username'] = username
      records[ record ]['password'] = password
      records[ record ]['workgroup'] = workgroup
    #add
    else
      records[ record ] = {
        'address' => address,
        'username' => username,
        'password' => password, 
        'workgroup' => workgroup
      } 
    end    

    
    File.open( MIGFILE, 'w', 0600 ) do |migfile| 
      YAML.dump( records , migfile)
    end
  end
  
  #Read a record from the file in YAML
  # 
  # :call-seq:
  #   Migration.evn_windows_read( record ) -> hash
  #   
  # Returns a hash of credential information
  def Migration.env_windows_read( record )
    records = Hash.new
    if File.exists?( MIGFILE )
      records = YAML.load( File.open( MIGFILE ))
    end
    
    if records.has_key?( record )
      return records[record]
    else
      return {}
    end
  end  
  
  # Get a record from the DB.  If the DB does not contain
  # the record we need get it from the user.
  # 
  # :call-seq:
  #   Migration.env_windows_credentials( record ) -> hash
  #   
  # Returns a hash of credential information
  def Migration.env_windows_credentials( record )
     credentials = Migration.env_windows_read( record )
     
     if credentials.empty? 
       credentials = Migration.env_windows_prompt( record )
        
       Migration.evn_windows_write( credentials )
     end
     return credentials 
  end
  #--------------------------------------------------------------------------
  # END WINDOWS
  #--------------------------------------------------------------------------
end
