# Copyright (C) [2006-2007] Novell, Inc.  All Rights Reserved.

# THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
# IT MAY NOT BE USED, COPIED, DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED,
# DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR WRITTEN
# CONSENT.  USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
# SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.

# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK,
# AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
# OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE,
# ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER
# DEALINGS IN THE WORK.

# :title: Novell Migration Utility - group_object
# ==Description: 
module Migration
  module Windows
    module Domain
      def Domain.random_password( size = 8 )
        chars = ("a".."z").to_a + (0..9).to_a + ("A".."Z").to_a + [ "@", "!", ".", "$", "?"]
        password = ""
    
        1.upto( size ) { |i| password << chars[rand(chars.length - 1)].to_s }
        
        password
      end
    
      def Domain.flatten_groups( target_groups, domain_groups )
        @current_list = []   # Groups that have already been flattened
        @domain_groups  = domain_groups
        
        target_groups.each do |group|
          @current_list << group.rid
          
          group.members = self.flatten_group( group.members )
          group.members.uniq! # Prune

          @current_list = [] # Reset current list
        end
      end
      
      def Domain.flatten_group_test( windows_groups )
        @current_list = []
        
        @target_groups = windows_groups        
        
        group = @windows_groups.first
        @current_list << group.rid
        
        group.members = self.flatten_group( group.members )        
        
        group.members.uniq!
        
        @current_list = []      
      end
      private
      def Domain.flatten_group( rids )
        results = []
        
        return results if rids.nil?        
        
        rids.each do |rid|
          # Groups that have already been flattened
          unless @current_list.include?( rid ) 
            # If the group list includes this rid then add it to current list
            # and then pass it through flatten_group
            group = @domain_groups.find { |x| x.rid == rid }
            unless group.nil?
              @current_list << rid
              results |= self.flatten_group( group.members )
            else
              # rid is not a group
              results << rid
            end
          end
        end
        results 
      end
    end
  end
end
