# Copyright (C) [2006-2007] Novell, Inc.  All Rights Reserved.

# THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
# IT MAY NOT BE USED, COPIED, DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED,
# DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR WRITTEN
# CONSENT.  USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
# SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.

# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
# PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK,
# AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
# OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE,
# ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER
# DEALINGS IN THE WORK.

# :title: Novell Migration Utility - ntuserls
# ==Description: 
# Module for NSS file system informaiton
#  
module Migration
  module Windows
    module Rights
      module NSS      
        # Order: SRWCEMFA
        # Char level
        NSS_SUPERVISOR_C     = 'S' #Not sure about this one in order
        NSS_MODIFY_C         = 'M'
        NSS_FILE_SCAN_C      = 'F'       
        NSS_ACCESS_CONTROL_C = 'A'
        NSS_ERASE_C          = 'E'
        NSS_CREATE_C         = 'C'
        NSS_WRITE_C          = 'W'        
        NSS_READ_C           = 'R'

        MAX_NSS_RIGHT = 0x80

        # Bit level   511 - 512
        NSS_READ             = 0x01
        NSS_WRITE            = 0x02
        NSS_CREATE           = 0x04
        NSS_ERASE            = 0x08
        NSS_ACCESS_CONTROL   = 0x10        
        NSS_FILE_SCAN        = 0x20
        NSS_MODIFY           = 0x40        
        NSS_SUPERVISOR       = 0x80
      end
    end
  end
end
